"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Badge = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireDefault(require("react"));

var _convertPx = require("../../utils/convert-px");

var _nativeProps = require("../../utils/native-props");

var _withDefaultProps = require("../../utils/with-default-props");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var classPrefix = "adm-badge";
var Badge = (0, _withDefaultProps.withDefaultProps)({
  color: '#FF411C',
  offset: [0, 0]
})(function (props) {
  var _classNames;

  var content = props.content,
      color = props.color,
      offset = props.offset,
      children = props.children;
  var badgeStyle = children ? {
    right: -(0, _convertPx.convertPx)(offset[0]) + "px",
    top: (0, _convertPx.convertPx)(offset[1]) + "px",
    backgroundColor: color
  } : {
    backgroundColor: color
  };
  var badgeCls = (0, _classnames["default"])(classPrefix, (_classNames = {}, _classNames[classPrefix + "-fixed"] = !!children, _classNames[classPrefix + "-dot"] = !content, _classNames));
  return (0, _nativeProps.withNativeProps)(props, children ? /*#__PURE__*/_react["default"].createElement("div", {
    className: classPrefix + "-wrap"
  }, children, /*#__PURE__*/_react["default"].createElement("div", {
    className: badgeCls,
    style: badgeStyle
  }, content)) : /*#__PURE__*/_react["default"].createElement("div", {
    className: badgeCls,
    style: badgeStyle
  }, content));
});
exports.Badge = Badge;