import React from 'react';
import classNames from 'classnames';
import { CheckCircleFill, CloseCircleFill, InformationCircleFill, ClockCircleFill, ExclamationCircleFill } from 'antd-mobile-icons';
var classPrefix = "adm-result";
var ICONS = {
  success: CheckCircleFill,
  error: CloseCircleFill,
  info: InformationCircleFill,
  waiting: ClockCircleFill,
  warning: ExclamationCircleFill
};
export var Result = function Result(props) {
  var className = props.className,
      style = props.style,
      status = props.status,
      title = props.title,
      description = props.description,
      icon = props.icon;
  var resultIcon = icon || /*#__PURE__*/React.createElement(ICONS[status]);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(classPrefix, classPrefix + "-" + status, className),
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-icon"
  }, resultIcon), /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-title"
  }, title), description ? /*#__PURE__*/React.createElement("div", {
    className: classPrefix + "-description"
  }, description) : null);
};
Result.defaultProps = {
  description: ''
};